gm composite
NAME
| composite - composite images together.
Contents
| Synopsis Description Examples Options Environment Configuration Files Authors Copyright
Synopsis
| composite [ options ... ] change-image base-image [ mask-image ] output-image
Description
| composite composites (combines) images to create new images. base-image is the base image and change-image contains the changes. ouput-image is the result, and normally has the same dimensions as base-image. The optional mask-image can be used to provide opacity information for change-image when it has none or if you want a different mask. A mask image is typically grayscale and the same size as base-image. If mask-image is not grayscale, it is converted to grayscale and the resulting intensities are used as opacity information.
Examples
| To composite an image of a cockatoo with a perch, use:
        gm composite cockatoo.miff perch.ras composite.miff
To compute the difference between images in a series, use:
        gm composite -compose difference series.2 series.1 difference.miff
To composite an image of a cockatoo with a perch starting at location (100,150), use:
        gm composite -geometry +100+150 cockatoo.miff perch.ras composite.miff
To tile a logo across your image of a cockatoo, use
        gm convert +shade 30x60 cockatoo.miff mask.miff
        gm composite -compose bumpmap -tile logo.png
                  cockatoo.miff mask.miff composite.miff
To composite a red, green, and blue color plane into a single composite image, try
        gm composite -compose CopyGreen green.png red.png red-green.png
        gm composite -compose CopyBlue blue.png red-green.png composite.png
Back to Contents
Options
| Options are processed in command line order. Any option you specify on the command line remains in effect only for the image that follows. All options are reset to their default values after each image is read. For a more detailed description of each option, see Options, above. GraphicsMagick(1).
| -authenticate <string>
| decrypt image with this password
| -background <color>
| the background color
| -blue-primary <x>,<y>
| blue chromaticity primary point
| -colors <value>
| preferred number of colors in the image
| -colorspace <value>
| the type of colorspace
| -comment <string>
| annotate an image with a comment
| -compose <operator>
| the type of image composition
| -compress <type>
| the type of image compression
| -debug <events>
| enable debug printout
| -define <key>{=<value>},...
| add coder/decoder specific options
| -density <width>x<height>
| horizontal and vertical resolution in pixels of the image
| -depth <value>
| depth of the image
| -displace <horizontal scale>x<vertical scale>
| shift image pixels as defined by a displacement map
| -display <host:display[.screen]>
| specifies the X server to contact
| -dispose <method>
| GIF disposal method
| -dissolve <percent>
| dissolve an image into another by the given percent
| -dither
| apply Floyd/Steinberg error diffusion to the image
| -encoding <type>
| specify the text encoding
| -endian <type>
| specify endianness (MSB, LSB, or Native) of image
| -filter <type>
| use this type of filter when resizing an image
| -font <name>
| use this font when annotating the image with text
| -geometry <width>x<height>{+-}<x>{+-}<y>{%}{@}{!}{^}{<}{>}
| preferred size and location of the Image window.
| -gravity <type>
| direction primitive gravitates to when annotating the image.
| -green-primary <x>,<y>
| green chromaticity primary point
| -help
| print usage instructions
| -interlace <type>
| the type of interlacing scheme
| -label <name>
| assign a label to an image
| -limit <type> <value>
| Disk, File, Map, Memory, Pixels, or Threads resource limit
| -log <string>
| Specify format for debug log
| -matte
| store matte channel if the image has one
| -monitor
| show progress indication
| -monochrome
| transform the image to black and white
| -negate
| replace every pixel with its complementary color
| -page <width>x<height>{+-}<x>{+-}<y>{%}{!}{<}{>}
| size and location of an image canvas
| -profile <filename>
| add ICM, IPTC, or generic profile to image
| -quality <value>
| JPEG/MIFF/PNG/TIFF compression level
| -recolor <matrix>
| apply a color translation matrix to image channels
| -red-primary <x>,<y>
| red chromaticity primary point
| -render
| render vector operations
| -resize <width>x<height>{%}{@}{!}{<}{>}
| resize an image
| -rotate <degrees>{<}{>}
| rotate the image
| -sampling-factor <horizontal_factor>x<vertical_factor>
| chroma subsampling factors
| -scene <value>
| set scene number
| -set <attribute> <value>
| set an image attribut
| -sharpen <radius>{x<sigma>}
| sharpen the image
| -size <width>x<height>{+offset}
| width and height of the image
| -stegano <offset>
| hide watermark within an image
| -stereo
| composite two images to create a stereo anaglyph
| -thumbnail <width>x<height>{%}{@}{!}{<}{>}
| resize an image (quickly)
| -treedepth <value>
| tree depth for the color reduction algorithm
| -trim
| trim an image
| -type <type>
| the image type
| -units <type>
| the units of image resolution
| -unsharp <radius>{x<sigma>}{+<amount>}{+<threshold>}
| sharpen the image with an unsharp mask operator
| -verbose
| print detailed information about the image
| -version
| print GraphicsMagick version string
| -watermark <brightness>x<saturation>
| percent brightness and saturation of a watermark
| -white-point <x>,<y>
| chromaticity white point
| -write <filename>
| write an intermediate image [convert, composite]
For a more detailed description of each option, see Options, above. GraphicsMagick(1).
Back to Contents
Environment
| COLUMNS
| Output screen width. Used when formatting text for the screen. Many Unix systems keep this shell variable up to date, but it may need to be explicitly exported in order for GraphicsMagick to see it.
| DISPLAY
| X11 display ID (host, display number, and screen in the form hostname:display.screen).
| HOME
| Location of user's home directory. GraphicsMagick searches for configuration files in $HOME/.magick if the directory exists. See MAGICK_CODER_MODULE_PATH, MAGICK_CONFIGURE_PATH, and MAGICK_FILTER_MODULE_PATH if more flexibility is needed.
| MAGICK_CODER_STABILITY
| The minimum coder stability level before it will be used. The available levels are PRIMARY, STABLE, and UNSTABLE. The default minimum level is UNSTABLE, which means that all available coders will be used. The purpose of this option is to reduce the security exposure (or apparent complexity) due to the huge number of formats supported. Coders at the PRIMARY level are commonly used formats with very well maintained implementations. Coders at the STABLE level are reasonably well maintained but represent less used formats. Coders at the UNSTABLE level either have weak implementations, the file format itself is weak, or the probability the coder will be needed is vanishingly small.
| MAGICK_CODER_MODULE_PATH
| Search path to use when searching for image format coder modules. This path allows the user to arbitrarily extend the image formats supported by GraphicsMagick by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_CONFIGURE_PATH
| Search path to use when searching for configuration (.mgk) files. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_DEBUG
| Debug options (see -debug for details)
| MAGICK_FILTER_MODULE_PATH
| Search path to use when searching for filter process modules (invoked via -process). This path allows the user to arbitrarily extend GraphicsMagick's image processing functionality by adding loadable modules to an arbitrary location rather than copying them into the GraphicsMagick installation directory. The formatting of the search path is similar to operating system search paths (i.e. colon delimited for Unix, and semi-colon delimited for Microsoft Windows). This user specified search path is used before trying the default search path.
| MAGICK_HOME
| Path to top of GraphicsMagick installation directory. Only observed by "uninstalled" builds of GraphicsMagick which do not have their location hard-coded or set by an installer.
| MAGICK_MMAP_READ
| If MAGICK_MMAP_READ is set to TRUE, GraphicsMagick will attempt to memory-map the input file for reading. This usually substantially improves read performance if the file has recently been read. However, testing shows that performance may be reduced for files accessed for the first time via a network since some operating systems failed to do read-ahead over network mounts for memory mapped files.
| MAGICK_MMAP_WRITE
| If MAGICK_MMAP_WRITE is set to TRUE, GraphicsMagick will attempt to memory-map the output file for writing. This is an experimental feature (which is currently broken). Write performance is usually somewhat worse when using this approach rather than the default one.
| MAGICK_IO_FSYNC
| If MAGICK_IO_FSYNC is set to TRUE, then GraphicsMagick will request that the output file is fully flushed and synchronized to disk when it is closed. This incurs a performance penalty, but has the benefit that if the power fails or the system crashes, the file should be valid on disk. If image files are referenced from a database, then this option helps assure that the files referenced by the database are valid.
| MAGICK_IOBUF_SIZE
| The amount of I/O buffering (in bytes) to use when reading and writing encoded files. The default is 16384, which is observed to work well for many cases. The best value for a local filesystem is usually the the native filesystem block size (e.g. 4096, 8192, or even 131,072 for ZFS) in order to minimize the number of physical disk I/O operations. I/O performance to files accessed over a network may benefit significantly by tuning this option. Larger values are not necessarily better (they may be slower!), and there is rarely any benefit from using values larger than 32768. Use convert's -verbose option in order to evaluate read and write rates in pixels per second while keeping in mind that the operating system will try to cache files in RAM.
| MAGICK_LIMIT_DISK
| Maximum amount of disk space allowed for use by the pixel cache.
| MAGICK_LIMIT_FILES
| Maximum number of open files.
| MAGICK_LIMIT_MAP
| Maximum size of a memory map.
| MAGICK_LIMIT_MEMORY
| Maximum amount of memory to allocate from the heap.
| MAGICK_TMPDIR
| Path to directory where GraphicsMagick should write temporary files. The default is to use the system default, or the location set by TMPDIR.
| TMPDIR
| For POSIX-compatible systems (Unix-compatible), the path to the directory where all applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.
| TMP or TEMP
| For Microsoft Windows, the path to the directory where applications should write temporary files. Overridden by MAGICK_TMPDIR if it is set.
| OMP_NUM_THREADS
| As per the OpenMP standard, this specifies the number of threads to use in parallel regions. Some compilers default the number of threads to use to the number of processor cores available while others default to just one thread. See the OpenMP specification for other standard adjustments and your compiler's manual for vendor-specific settings.
Back to Contents
Configuration Files
| GraphicsMagick uses a number of XML format configuration files:
| colors.mgk
| colors configuration file
      <?xml version="1.0"?>
      <colormap>
        <color name="AliceBlue" red="240" green="248" blue="255"
               compliance="SVG, X11, XPM" />
      </colormap>
| delegates.mgk
| delegates configuration file
| log.mgk
| logging configuration file
      <?xml version="1.0"?>
      <magicklog>
        <log events="None" />
        <log output="stdout" />
        <log filename="Magick-%d.log" />
        <log generations="3" />
        <log limit="2000" />
        <log format="%t %r %u %p %m/%f/%l/%d:\n  %e"  />
      </magicklog>
| modules.mgk
| loadable modules configuration file
      <?xml version="1.0"?>
      <modulemap>
        <module magick="8BIM" name="META" />
      </modulemap>
| type.mgk
| master type (fonts) configuration file
      <?xml version="1.0"?>
      <typemap>
        <include file="type-windows.mgk" />
        <type
          name="AvantGarde-Book"
          fullname="AvantGarde Book"
          family="AvantGarde"
          foundry="URW"
          weight="400"
          style="normal"
          stretch="normal"
          format="type1"
          metrics="/usr/local/share/ghostscript/fonts/a010013l.afm"
          glyphs="/usr/local/share/ghostscript/fonts/a010013l.pfb"
        />
      </typemap>
Back to Contents
Authors
| John Cristy, Bob Friesenhahn, Glenn Randers-Pehrson, William Radcliff, Leonard Rosenthol.
Back to Contents
Copyright
| Copyright (C) 2002 - 2010 GraphicsMagick Group, an organization dedicated to making software imaging solutions freely available. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files ("GraphicsMagick"), to deal in GraphicsMagick without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of GraphicsMagick, and to permit persons to whom GraphicsMagick is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of GraphicsMagick. The software is provided "as is", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness for a particular purpose and noninfringement. In no event shall GraphicsMagick Group be liable for any claim, damages or other liability, whether in an action of contract, tort or otherwise, arising from, out of or in connection with GraphicsMagick or the use or other dealings in GraphicsMagick. Except as contained in this notice, the name of the GraphicsMagick Group shall not be used in advertising or otherwise to promote the sale, use or other dealings in GraphicsMagick without prior written authorization from the GraphicsMagick Group. Additional copyrights and licenses apply to this software. You should have received a copy of Copyright.txt with this package, which describes additional copyrights and licenses which apply to this software; otherwise see http://www.graphicsmagick.org/Copyright.html.
Back to Contents [Home] [Utilities Index] Copyright © GraphicsMagick Group 2002 - 2010